;===============================================================
; () 
; 1.0
; - P16F873A
; .. 4 
;   1k
;  ..
;****************************************************************
	#include "P16F873A.INC"               ; .  . 
	LIST    p=16F873A  	; 

   ERRORLEVEL      -202                ;  302   
   ERRORLEVEL      -302                ;  302   
   ERRORLEVEL      -306                ;  306  

   __CONFIG     B'01100000110001' ;
;*********************************************************
;  
;    PORTA,0         ; .
;    PORTA,1         ;   TMP-36
;    PORTA,2          ;  TMP-36
;    PORTA,3         ; 
;    PORTA,4         ;
;    PORTA,5         ;

;    PORTB,0         ; 
;    PORTB,1         ; 
;    PORTB,2         ;LCD-RS
;    PORTB,3         ;LCD-E ()
;    PORTB,4         ;LCD-D4
;    PORTB,5         ;LCD-D5
;    PORTB,6         ;LCD-D6
;    PORTB,7         ;LCD-D7

;    PORTC,0         ;DHT22
;    PORTC,1         ;SDA BMP180
;    PORTC,2         ;SCL BMP180
;    PORTC,3         ;
;    PORTC,4         ;SDS011
;    PORTC,5         ;SDS011
;    PORTC,6         ;MH-Z19B
;    PORTC,7         ;MH-Z19B
;*****************************************************************************
Sec           equ         0020h             ;  
Sec1          equ         0021h             ;
Sec2          equ         0022h             ;
nomer         equ         0023h             ;   ascii 
scetbit       equ         0024h             ;  -   
perem         equ         0025h             ;  /   spi, i2c                
temp          equ         0026h             ;  
tmp_symb      equ         0027h             ;      
oss           equ         0028h             ;      

DIGIT1        equ         0030h             ;     
DIGIT2        equ         0031h             ;   
DIGIT3        equ         0032h
DIGIT4        equ         0033h
DIGIT5        equ         0034h          
DIGIT6        equ         0035h
DIGIT7        equ         0036h
DIGIT8        equ         0037h
DIGIT9        equ         0038h
DIGIT10       equ         0039h
count_1       equ         003Ah
count_2       equ         003Bh
bin_HH        equ         003Ch
bin_HL        equ         003Dh
bin_LH        equ         003Eh
bin_LL        equ         003Fh


adr_i2c       equ         0040h             ;     i2c
tmp_i2c       equ         0041h
slave_adr     equ         0042h
data_i2c      equ         0043h

AC1_LH        equ         00A0h             ;     BMP180
AC1_LL        equ         00A1h
AC2_LH        equ         00A2h
AC2_LL        equ         00A3h
AC3_LH        equ         00A4h
AC3_LL        equ         00A5h
AC4_LH        equ         00A6h
AC4_LL        equ         00A7h
AC5_LH        equ         00A8h
AC5_LL        equ         00A9h
AC6_LH        equ         00AAh
AC6_LL        equ         00ABh
B1_LH         equ         00ACh
B1_LL         equ         00ADh
B2_LH         equ         00AEh
B2_LL         equ         00AFh
MB_LH         equ         00B0h
MB_LL         equ         00B1h
MC_LH         equ         00B2h
MC_LL         equ         00B3h
MD_LH         equ         00B4h
MD_LL         equ         00B5h

X1_HH         equ         00B6h             ;        BMP180
X1_HL         equ         00B7h
X1_LH         equ         00B8h
X1_LL         equ         00B9h
X2_HH         equ         00BAh
X2_HL         equ         00BBh
X2_LH         equ         00BCh
X2_LL         equ         00BDh
X3_HH         equ         00BEh
X3_HL         equ         00BFh
X3_LH         equ         00C0h
X3_LL         equ         00C1h
B3_HH         equ         00C2h
B3_HL         equ         00C3h
B3_LH         equ         00C4h
B3_LL         equ         00C5h
B5_HH         equ         00C6h
B5_HL         equ         00C7h
B5_LH         equ         00C8h
B5_LL         equ         00C9h
B4_HH         equ         00CAh
B4_HL         equ         00CBh
B4_LH         equ         00CCh
B4_LL         equ         00CDh
B6_HH         equ         00CEh
B6_HL         equ         00CFh
B6_LH         equ         00D0h
B6_LL         equ         00D1h

REGA3         equ         00D2h
REGA2         equ         00D3h
REGA1         equ         00D4h
REGA0         equ         00D5h
REGB3         equ         00D6h
REGB2         equ         00D7h
REGB1         equ         00D8h
REGB0         equ         00D9h
REGC3         equ         00DAh
REGC2         equ         00DBh
REGC1         equ         00DCh
REGC0         equ         00DDh
MTEMP         equ         00DEh
MCOUNT        equ         00DFh

P_HH          equ         00E0h             ;   
P_HL          equ         00E1h
P_LH          equ         00E2h
P_LL          equ         00E3h

P_M           equ         00E4h             ;      ..
P_L           equ         00E5h

T_HH          equ         00E6h             ;   
T_HL          equ         00E7h
T_LH          equ         00E8h
T_LL          equ         00E9h
 
tmp           equ         00EAh             ;  
flag          equ         007Fh             ; 



cblock   0x45
Count		; 
Count2		; 
R_Count
REG_T     ; 
REG_SL    ;
U_TIMER


Rt_L
Rt_H
 Rh_L
Rh_H
 RCO_L
RCO_H
; RPr_L
;RPr_H
D_L
D_H

;shet
;vlag_L
;vlag_H
;temp_L
;temp_H
;res_tmp
;tmp_rsv



LED0		;  
LED1	
LED2	
LED3	
LED4	 
LED5	
LED6	
LED7	
LED8	
Temp		; 
LEDtemp		; LED

TimerL		; 
TimerM		; 
TimerH		; 
TimerHH		;  

TempL		; 
TempM		; 
TempH		; 



  TEMP_L               ;
TEMP_M              ;
TEMP_H             ;
TEMP_HH               ;
          TEMP_HHH               ;
  TEMP_L1               ;
TEMP_M1              ;
TEMP_H1             ;
TEMP_HH1              ;
          TEMP_HHH1              ;
  TEMP_L2               ;
TEMP_M2              ;
TEMP_H2             ;
TEMP_HH2               ;
           TEMP_HHH2              ;


R_Cont
STATUS_TEMP
W_TEMP

 endc
;***************

#DEFINE       sda         PORTC,1           ; SDA    BMP180
#DEFINE       scl         PORTC,2           ; SCL    BMP180
#DEFINE       sda_io      TRISC,1           ;  SDA 
#DEFINE       scl_io      TRISC,2           ;  SCL 
#DEFINE       led         PORTA,0           ;  i2c

#DEFINE       datchik     PORTC,0           ;    DHT22
;******************************************************************************
;  PORTA 
RA7          EQU    07H
RA6          EQU    06H
RA5          EQU    05H
RA4          EQU    04H
RA3          EQU    03H
RA2          EQU    02H
RA1          EQU    01H
RA0          EQU    00H
;***************************************************************
;  PORTB 
RB7          EQU    07H
RB6          EQU    06H
RB5          EQU    05H
RB4          EQU    04H
RB3          EQU    03H
RB2          EQU    02H
RB1          EQU    01H
RB0          EQU    00H
;***************************************************************
;  PORTC 
RC7          EQU    07H
RC6          EQU    06H
RC5          EQU    05H
RC4          EQU    04H
RC3          EQU    03H
RC2          EQU    02H
RC1          EQU    01H
RC0          EQU    00H
;=============================================
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ORG        00H            ;   .
            GOTO    _INIT              ;  
        ORG        04H            ;
           RETFIE                    ;
;*******************************************************     
;  
;***********************************************************
_INIT                              ; . 
        BSF     STATUS,RP0         ;  2-  
      MOVLW   B'00111111'        ; PORTA:RA0-RA5- ,
        MOVWF   TRISA              ;  
        MOVLW   B'00000000'        ; PORT:0,4,5- ,. 
        MOVWF   TRISB              ;  TRISB
        MOVLW   B'11001111'        ;
        MOVWF   TRISC              ;  TRISC
        MOVLW   B'10000111'        ;  OPTION (=256)
        MOVWF   OPTION_REG         ;
            CLRF	PIE2	;CCP2 .

     CLRF    CVRCON              ;
     movlw   B'00000111'       ;. OFF
     movwf   CMCON           ;

        BCF     STATUS,RP0         ;  1-  

        CLRF   TMR0              ;
      CLRF   INTCON         ;
        CLRF   PIR1         ;
        CLRF   PIE1         ;
        CLRF   PORTA              ;
        CLRF   PORTB              ;
        CLRF   PORTC              ;
        bsf     STATUS,RP0
        bcf     TXSTA,TXEN      ;..
        bcf     STATUS,RP0
        bcf     RCSTA,SPEN      ; .

             BCF	T1CON,0		;.
          CLRF	T2CON		; 2 .
      CALL    AD_OFF               ;
        CALL   INIT_GKI                ;           



;     GOTO    T_02mS



;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;**************************************************************
Start                          ;
        CALL   INIT_0                ;
   	movlw	b'00000001'       	; 
	call	LEDcom               ;
      CALL    A_METR              ;   -
      CALL    T2S               ;

Start_0                          ;
           CALL     TEM_RE0              ;
           CALL     Start_bmp              ;
           CALL     Start_bht              ;
           CALL     Start_CO2              ;
;           CALL     Start_Dust              ;


       GOTO    Start_0              ;

;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
; 
;The thermometer*******outside temperature***************************************
TEM_RE0                      ;
   	movlw	b'00000001'       	; 
	call	LEDcom               ;
      CALL    T_METR              ;   -

        movlw   B'01001001'       ; B'01011001'
     movwf   ADCON0           ;
              movlw   B'10000000'       ;
     bsf     STATUS,RP0       ;
     movwf   ADCON1           ;
     bcf     STATUS,RP0       ;
       CLRF    U_TIMER              ;
T_AD1                             ;  s
       INCF   U_TIMER,F              ;
       BTFSS  U_TIMER,3              ;
       GOTO    T_AD1               ;
       CLRF    U_TIMER              ;
     BSF     ADCON0,2          ; 
        BTFSC    ADCON0,2           ;
        GOTO    $-1                ;
            MOVLW   .25        ;
               bsf     STATUS,RP0       ;
            SUBWF   ADRESL,W          ;
               bcf     STATUS,RP0       ;
        BTFSS   STATUS,C            ;
            GOTO   TEM__RE0
            MOVLW   .52        ;!!!!!!!!!!!!
               bsf     STATUS,RP0       ;
         SUBWF   ADRESL,F          ;
              bcf     STATUS,RP0       ;
        BTFSS   STATUS,C            ;
     GOTO    TEM_RE2                ;
      BCF     REG_SL,0         ;
      GOTO    TEM_RE3                ;
TEM_RE2                      ;
           bsf     STATUS,RP0       ;
         COMF   ADRESL,F              ;
           bcf     STATUS,RP0       ;
      BSF     REG_SL,0         ;
TEM_RE3                      ;
           bsf     STATUS,RP0       ;
          MOVF   ADRESL,W           ;
           bcf     STATUS,RP0       ;
       MOVWF   TimerL              ;
       CALL   Bin2LCD              ;
	movlw	b'11000000'	;   
	call	LEDcom		;Temperature 
	movlw	24h	                  ;T
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata

	movlw	1FDh	           ;-
           BTFSC   REG_SL,0            ;
	call	LEDdata
        MOVF   LED2,0              ;
	    call	LEDdata            ;
        MOVF   LED1,0              ;
	    call	LEDdata            ;
        MOVF   LED0,0              ;
	    call	LEDdata            ;
    	movlw	1AFh	           ;.
    	call	LEDdata 
	movlw	13h	                  ;C
	call	LEDdata
	movlw	1F0h	           ;
           BTFSS   REG_SL,0            ;
	call	LEDdata
;********
TEM__RE0                      ;
        movlw   B'01010001'       ;
     movwf   ADCON0           ;
              movlw   B'10000000'       ;
     bsf     STATUS,RP0       ;
     movwf   ADCON1           ;
     bcf     STATUS,RP0       ;
       CLRF    U_TIMER              ;
T__AD1                             ;  s
       INCF   U_TIMER,F              ;
       BTFSS  U_TIMER,3              ;
       GOTO    T__AD1               ;
       CLRF    U_TIMER              ;
     BSF     ADCON0,2          ; 
        BTFSC    ADCON0,2           ;
        GOTO    $-1                ;
            MOVLW   .25        ;
               bsf     STATUS,RP0       ;
            SUBWF   ADRESL,W          ;
               bcf     STATUS,RP0       ;
        BTFSS   STATUS,C            ;
            GOTO   TEM_RE
            MOVLW   .52        ;!!!!!!!!!!!!
               bsf     STATUS,RP0       ;
         SUBWF   ADRESL,F          ;
              bcf     STATUS,RP0       ;
        BTFSS   STATUS,C            ;
     GOTO    TEM__RE2                ;
      BCF     REG_SL,0         ;
      GOTO    TEM__RE3                ;
TEM__RE2                      ;
           bsf     STATUS,RP0       ;
         COMF   ADRESL,F              ;
           bcf     STATUS,RP0       ;
      BSF     REG_SL,0         ;
TEM__RE3                      ;
           bsf     STATUS,RP0       ;
          MOVF   ADRESL,W           ;
           bcf     STATUS,RP0       ;
       MOVWF   TimerL              ;
       CALL   Bin2LCD              ;
	movlw	b'11001000'	;   
	call	LEDcom		;Temperature 
	movlw	24h	                  ;T
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata

	movlw	1FDh	           ;-
           BTFSC   REG_SL,0            ;
	call	LEDdata
        MOVF   LED2,0              ;
	    call	LEDdata            ;
        MOVF   LED1,0              ;
	    call	LEDdata            ;
        MOVF   LED0,0              ;
	    call	LEDdata            ;
    	movlw	1AFh	           ;.
    	call	LEDdata 
	movlw	13h	                  ;C
	call	LEDdata
	movlw	1F0h	           ;
           BTFSS   REG_SL,0            ;
	call	LEDdata

TEM_RE                      ;



      CALL    AD_OFF               ;




      CALL    T2S               ;
             RETURN             ;
;******   - outside temperature************************************
T_METR 
	movlw	b'10000001'	;   
	call	LEDcom		;
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	25h	                ;U
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata
      movlw	 50h	         ;
      call	LEDdata                 ;
	movlw	24h	                  ;T
	call	LEDdata
	movlw	15h	                  ;E
	call	LEDdata
	movlw	1Dh	                  ;M
	call	LEDdata
	movlw	20h	                  ;P
	call	LEDdata
	movlw	15h	                  ;E
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
	movlw	11h	               ;A
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata
	movlw	25h	                ;U
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
	movlw	15h	                  ;E
	call	LEDdata
       RETURN                      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      BMP180
;**************pressure***********
Start_bmp   
   	movlw	b'00000001'       	; 
	call	LEDcom               ;
      CALL    P_METR              ;   -


      BSF   PCLATH,3
      BCF   PCLATH,4
       GOTO   bmp_0                 ;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    LCD 
vivod_temp 
       MOVF    bin_LL,W             ;
       MOVWF    TimerL             ;
     MOVF    bin_LH,W             ;
       MOVWF    TimerM             ;
     MOVF    bin_HL,W             ;
       MOVWF    TimerH             ;
     MOVF    bin_HH,W             ;
       MOVWF    TimerHH             ;
;           CALL    INIT_T2
        CALL   Bin2LCD              ;
           CALL    T_IND
      CALL    T2S               ;
              RETURN                     ;
;*************************
T_IND                        ; 
	movlw	b'11000000'	;   
	call	LEDcom		;
	movlw	24h	                  ;T
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
        MOVF   LED2,W              ;
	    call	LEDdata            ;
        MOVF   LED1,W              ;
	    call	LEDdata            ;
    	movlw	1FCh	           ;,
    	call	LEDdata             ;
        MOVF   LED0,W              ;
	    call	LEDdata            ;
    	movlw	1AFh	           ;.
    	call	LEDdata 
	movlw	13h	               ;C
	call	LEDdata
    	movlw	1F0h	           ;
	call	LEDdata
	movlw	1F0h	           ;
	call	LEDdata
	movlw	1F0h	           ;
	call	LEDdata
	movlw	1F0h	           ;
	call	LEDdata
              RETURN                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   ()  LCD 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vivod_p   
       MOVF    bin_LL,W             ;
       MOVWF    TimerL             ;
     MOVF    bin_LH,W             ;
       MOVWF    TimerM             ;
     MOVF    bin_HL,W             ;
       MOVWF    TimerH             ;
     MOVF    bin_HH,W             ;
       MOVWF    TimerHH             ;
        CALL   Bin2LCD              ;
           CALL    Pr_IND
      CALL    T2S               ;
              RETURN                     ;
;*************************
Pr_IND                        ; 
	movlw	b'11000000'	;   
	call	LEDcom		;
	movlw	20h	                  ;P
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
        MOVF   LED5,W              ;
	    call	LEDdata            ;
        MOVF   LED4,W              ;
	    call	LEDdata            ;
        MOVF   LED3,W              ;
	    call	LEDdata            ;
        MOVF   LED2,W              ;
	    call	LEDdata            ;
    	movlw	1FCh	           ;,
    	call	LEDdata             ;
        MOVF   LED1,W              ;
	    call	LEDdata            ;
        MOVF   LED0,W              ;
	    call	LEDdata            ;
	movlw	38h	             ;h
	call	LEDdata
	movlw	20h	                  ;P
	call	LEDdata
	movlw	31h	               ;a
	call	LEDdata
    	movlw	1F0h	           ;
	call	LEDdata
	movlw	1F0h	           ;
	call	LEDdata
	movlw	1F0h	           ;
	call	LEDdata
	movlw	1F0h	           ;
	call	LEDdata
              RETURN                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   ( . .)  LCD 
viv_p_mm    
       MOVF    bin_LL,W             ;
       MOVWF    TimerL             ;
     MOVF    bin_LH,W             ;
       MOVWF    TimerM             ;
     MOVF    bin_HL,W             ;
       MOVWF    TimerH             ;
     MOVF    bin_HH,W             ;
       MOVWF    TimerHH             ;
        CALL   Bin2LCD              ;
           CALL    Pr__IND
      CALL    T2S               ;
              RETURN                     ;
;*************************
Pr__IND                        ; 
	movlw	b'11001001'	;   
	call	LEDcom		;
	movlw	20h	                  ;P
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
        MOVF   LED2,W              ;
	    call	LEDdata            ;
        MOVF   LED1,W              ;
	    call	LEDdata            ;
        MOVF   LED0,W              ;
	    call	LEDdata            ;
	movlw	3Dh	                  ;m
	call	LEDdata
	movlw	3Dh	                  ;m
	call	LEDdata
              RETURN                     ;

;******    - pressure************************************
P_METR 
	movlw	b'10000011'	;   
	call	LEDcom		;

	movlw	20h	                  ;P
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
	movlw	15h	                  ;E
	call	LEDdata
   	movlw	23h	             ;   S
	call	LEDdata
   	movlw	23h	             ;   S
	call	LEDdata
	movlw	25h	                ;U
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
	movlw	15h	                  ;E
	call	LEDdata
       RETURN                      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      DHT22
;**************humidity***********
Start_bht
   	movlw	b'00000001'       	; 
	call	LEDcom               ;
      CALL    H_METR              ;   -
      CALL    PH_t_1              ;          
      CALL    T2S               ;
       RETURN                      ;
;=============================================
;  
;=============================================
PH_t_1                               ;
        BSF     STATUS,RP0         ;  2-  
       BCF    TRISC,0            ; 
        BCF     STATUS,RP0         ;  1-  
       BCF    PORTC,RC0            ;
            CALL    T_20mS               ;
        BSF     STATUS,RP0         ;  2-  
       BSF    TRISC,0            ; 
        BCF     STATUS,RP0         ;  1-  
            CALL    T_60uS               ;
PH_t_10                               ;
       BTFSS   PORTC,RC0            ;
        GOTO   PH_t_10          ;
PH_t_11                               ;
       BTFSC   PORTC,RC0            ;
        GOTO   PH_t_11          ;

        CLRF   Count              ;
        BCF     STATUS,C         ;
        GOTO   PH_h_D0          ;
;
PH_h_D00                               ;
     RLF    Rh_H,F          ;   
PH_h_D0                               ;
       BTFSS   PORTC,RC0            ;
        GOTO   PH_h_D0          ;
        CLRF   R_Count              ;
PH_h_D1                               ;
       BTFSS   R_Count,3            ;
       INCF  R_Count,F              ;
       BTFSC   PORTC,RC0            ;
        GOTO   PH_h_D1          ;
       BTFSC   R_Count,3           ;
        BSF     Rh_H,0          ;
       BTFSS   R_Count,3           ;
        BCF     Rh_H,0          ;
        CLRF   R_Count              ;
       INCF  Count,F              ;
       BTFSS   Count,3            ;
            GOTO   PH_h_D00          ;

        CLRF   Count              ;
        BCF     STATUS,C         ;
        GOTO   PH_h_D10          ;
PH_h_D01                               ;
     RLF    Rh_L,F          ;   
PH_h_D10                               ;
       BTFSS   PORTC,RC0            ;
        GOTO   PH_h_D10          ;
        CLRF   R_Count              ;
PH_h_D11                               ;
       BTFSS   R_Count,3            ;
       INCF  R_Count,F              ;
       BTFSC   PORTC,RC0            ;
        GOTO   PH_h_D11          ;
       BTFSC   R_Count,3           ;
        BSF     Rh_L,0          ;
       BTFSS   R_Count,3           ;
        BCF     Rh_L,0          ;
        CLRF   R_Count              ;
       INCF  Count,F              ;
       BTFSS   Count,3            ;
            GOTO   PH_h_D01          ;

        CLRF   Count              ;
        BCF     STATUS,C         ;
        GOTO   PH_t_D0          ;
;
PH_t_D00                               ;
     RLF    Rt_H,F          ;   
PH_t_D0                               ;
       BTFSS   PORTC,RC0            ;
        GOTO   PH_t_D0          ;
        CLRF   R_Count              ;
PH_t_D1                               ;
       BTFSS   R_Count,3            ;
       INCF  R_Count,F              ;
       BTFSC   PORTC,RC0            ;
        GOTO   PH_t_D1          ;
       BTFSC   R_Count,3           ;
        BSF     Rt_H,0          ;
       BTFSS   R_Count,3           ;
        BCF     Rt_H,0          ;
        CLRF   R_Count              ;
       INCF  Count,F              ;
       BTFSS   Count,3            ;
            GOTO   PH_t_D00          ;

        CLRF   Count              ;
        BCF     STATUS,C         ;
        GOTO   PH_t_D10          ;
PH_t_D01                               ;
     RLF    Rt_L,F          ;   
PH_t_D10                               ;
       BTFSS   PORTC,RC0            ;
        GOTO   PH_t_D10          ;
        CLRF   R_Count              ;
PH_t_D11                               ;
       BTFSS   R_Count,3            ;
       INCF  R_Count,F              ;
       BTFSC   PORTC,RC0            ;
        GOTO   PH_t_D11          ;
       BTFSC   R_Count,3           ;
        BSF     Rt_L,0          ;
       BTFSS   R_Count,3           ;
        BCF     Rt_L,0          ;
        CLRF   R_Count              ;
       INCF  Count,F              ;
       BTFSS   Count,3            ;
            GOTO   PH_t_D01          ;
;=============================================
;PH_t                               ;
       MOVF    Rh_L,W             ;
       MOVWF    TimerL             ;
     MOVF    Rh_H,W             ;
       MOVWF    TimerM             ;
           CALL    INIT_T2
        CALL   Bin2LCD              ;
           CALL    H_IND
       MOVF    Rt_L,W             ;
       MOVWF    TimerL             ;
     MOVF    Rt_H,W             ;
       MOVWF    TimerM             ;
           CALL    INIT_T2
        CALL   Bin2LCD              ;
           CALL    T__IND
              RETURN                     ;
;**********************************************************
;******************************************************
H_IND                        ; 
	movlw	b'11000000'	;   
	call	LEDcom		;
	movlw	18h	             ;   H
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
        MOVF   LED2,W              ;
	    call	LEDdata            ;
        MOVF   LED1,W              ;
	    call	LEDdata            ;
    	movlw	1FCh	           ;,
    	call	LEDdata             ;
        MOVF   LED0,W              ;
	    call	LEDdata            ;
   	movlw	1F5h	           ;%
    	call	LEDdata             ;
              RETURN                     ;
;*************************
T__IND                        ; 
	movlw	b'11001000'	;   
	call	LEDcom		;
	movlw	24h	                  ;T
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
        MOVF   LED2,W              ;
	    call	LEDdata            ;
        MOVF   LED1,W              ;
	    call	LEDdata            ;
    	movlw	1FCh	           ;,
    	call	LEDdata             ;
        MOVF   LED0,W              ;
	    call	LEDdata            ;
    	movlw	1AFh	           ;.
    	call	LEDdata 
	movlw	13h	               ;C
	call	LEDdata
              RETURN                     ;
;******    - humidity***************
H_METR 
	movlw	b'10000011'	;   
	call	LEDcom		;

	movlw	18h	             ;   H
	call	LEDdata
	movlw	25h	                ;U
	call	LEDdata
	movlw	1Dh	                  ;M
	call	LEDdata
       	movlw	19h	                  ;I
	call	LEDdata
	movlw	14h	                  ;D
	call	LEDdata
       	movlw	19h	                  ;I
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata
	movlw	29h	                ;Y
	call	LEDdata
       RETURN                      ;
;**********************************************************
;*************************
;  CO2
;=============================================
;Start_CO2         ;  
   	movlw	b'00000001'       	; 
	call	LEDcom               ;
      CALL    CO_METR              ;   -

                CALL    CO2_data               ;

       MOVF    RCO_L,W             ;
       MOVWF    TimerL             ;
     MOVF    RCO_H,W             ;
       MOVWF    TimerM             ;
           CALL    INIT_T2
        CALL   Bin2LCD              ;
           CALL    CO2_IND
      CALL    T2S               ;


	bsf	STATUS,RP0
	bcf	TXSTA,TXEN      ; 
	bcf	STATUS,RP0
	bcf	RCSTA,CREN     ; 
	bcf	RCSTA,SPEN     ; USART 


          RETURN                      ;

;*************************
Start_CO2         ;  
   	movlw	b'00000001'       	; 
	call	LEDcom               ;
      CALL    CO_METR              ;   -


                CALL    CO2_PWM               ;


;        CLRF   TimerL             ;
 ;     MOVLW   .3        ;
  ;     MOVWF    TimerM             ;





       MOVF    RCO_L,W             ;
       MOVWF    TimerL             ;
     MOVF    RCO_H,W             ;
       MOVWF    TimerM             ;




           CALL    INIT_T2
        CALL   Bin2LCD              ;
           CALL    CO2_IND
      CALL    T2S               ;

          RETURN                      ;

CO2_PWM                        ;
              clrf        RCO_L             ;
              clrf        RCO_H             ;
	btfss	PORTA,RA3		
	goto	$-1

    	btfsc	PORTA,RA3		
              goto      $-1             ;
	btfss	PORTA,RA3		
	goto	$-1

CO2_PWM1                        ;

                 	call   T_02mS
        incf     RCO_L,f
	btfsc	STATUS,Z		
        incf     RCO_H,f
    	btfsc	PORTA,RA3		
              goto      CO2_PWM1             ;
       	return

;*************************
CO2_data                        ;
;086          ,
;  HIGH (3)  LOW (4)    CO2;
;-------------------------------;  USART

	bsf	STATUS,RP0
	movlw	.25		;  9600
	movwf	SPBRG		
	bsf	TXSTA,BRGH       ;High speed ()	
	bcf	TXSTA,SYNC        ;Asynchronous mode
	bsf	TXSTA,TXEN      ; 
	bcf	STATUS,RP0
	bsf	RCSTA,SPEN     ; USART 

                 	call   T_20mS

	call	out_1
	bsf	RCSTA,CREN     ; 
	call	in_1
       	return

;----------------------------------------------------
;-------------------------------------------------
out_1			; 

	movlw	0FFh		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	01h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	86h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	79h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	return
;-------------------------------------------------
in_1			; 

	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,F           ;
	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,F           ;
	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,W           ; 
              movwf       RCO_H
	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,W           ; 
              movwf       RCO_L


	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,F           ;
	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,F           ;
	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,F           ;
	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,F           ;
	btfss	PIR1,RCIF		
	goto	$-1
              movf        RCREG,F           ;

    	return
;*************************
CO2_cal                        ;   
;087         
;   (400ppm)

	movlw	0FFh		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	01h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	87h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	78h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	return
;*************************
out_busy
	btfss	PIR1,TXIF		
	goto	out_busy
	return
;*************************************************
;*************************
CO2_IND                        ; 
	movlw	b'11000000'	;   
	call	LEDcom		;
	movlw	13h	               ;C
	call	LEDdata
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	02h	               ;2
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
        MOVF   LED3,W              ;
	    call	LEDdata            ;
        MOVF   LED2,W              ;
	    call	LEDdata            ;
        MOVF   LED1,W              ;
	    call	LEDdata            ;
        MOVF   LED0,W              ;
	    call	LEDdata            ;
	movlw	40h	                  ;p
	call	LEDdata
	movlw	40h	                  ;p
	call	LEDdata
	movlw	3Dh	                  ;m
	call	LEDdata
              RETURN                     ;
;*************************
;******    - carbon dioxide*************
CO_METR 
	movlw	b'10000001'	;   
	call	LEDcom		;

	movlw	13h	               ;C
	call	LEDdata
	movlw	11h	               ;A
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
	movlw	12h	               ;B
	call	LEDdata
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	1Eh	                  ;N
	call	LEDdata

	movlw	1F0h	           ;
	call	LEDdata

	movlw	14h	                  ;D
	call	LEDdata
       	movlw	19h	                  ;I
	call	LEDdata
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	28h	                  ;W
	call	LEDdata
       	movlw	19h	                  ;I
	call	LEDdata
	movlw	14h	                  ;D
	call	LEDdata
       	movlw	15h	                  ;E
	call	LEDdata
       RETURN                      ;
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;**********************************************************
;*************************
;
;=============================================
Start_Dust         ; 
   	movlw	b'00000001'       	; 
	call	LEDcom               ;
      CALL    Dust_METR              ;   -

       MOVF    D_L,W             ;
       MOVWF    TimerL             ;
     MOVF    D_H,W             ;
       MOVWF    TimerM             ;
           CALL    INIT_T2
        CALL   Bin2LCD              ;
           CALL    Dust_IND1
      CALL    T2S               ;




       MOVF    D_L,W             ;
       MOVWF    TimerL             ;
     MOVF    D_H,W             ;
       MOVWF    TimerM             ;
           CALL    INIT_T2
        CALL   Bin2LCD              ;
           CALL    Dust_IND2
      CALL    T2S               ;





          RETURN                      ;
;*************************
Dust_IND1                        ; 
	movlw	b'11000000'	;   
	call	LEDcom		;
	movlw	20h	                  ;P
	call	LEDdata
	movlw	1Dh	                  ;M
	call	LEDdata
    	movlw	02h	                  ;2
   call	LEDdata 
    	movlw	1FEh	           ;
    	call	LEDdata             ;
    	movlw	05h	                  ;5
   call	LEDdata            ;           ;
	movlw	0Dh	           ;=
	call	LEDdata
;        MOVF   LED3,W              ;
;	    call	LEDdata            ;
        MOVF   LED2,W              ;
	    call	LEDdata            ;
        MOVF   LED1,W              ;
	    call	LEDdata            ;
        MOVF   LED0,W              ;
	    call	LEDdata            ;
	movlw	45h	                ;u
	call	LEDdata
    	movlw	37h	                  ;g
	call	LEDdata
	movlw	0FFh	                  ;/
	call	LEDdata
	movlw	3Dh	                  ;m
	call	LEDdata
    	movlw	03h	                  ;3
   call	LEDdata            ;
              RETURN                     ;
;*************************
Dust_IND2                        ; 
	movlw	b'11000000'	;   
	call	LEDcom		;
	movlw	20h	                  ;P
	call	LEDdata
	movlw	1Dh	                  ;M
	call	LEDdata
    	movlw	01h	                  ;1
   call	LEDdata 
    	movlw	00h	                  ;0
   call	LEDdata            ;           ;
	movlw	0Dh	           ;=
	call	LEDdata
        MOVF   LED2,W              ;
	    call	LEDdata            ;
        MOVF   LED1,W              ;
	    call	LEDdata            ;
        MOVF   LED0,W              ;
	    call	LEDdata            ;
	movlw	45h	                ;u
	call	LEDdata
    	movlw	37h	                  ;g
	call	LEDdata
	movlw	0FFh	                  ;/
	call	LEDdata
	movlw	3Dh	                  ;m
	call	LEDdata
    	movlw	03h	                  ;3
   call	LEDdata            ;
      movlw	 50h	         ;
      call	LEDdata                 ;
              RETURN                     ;
;*************************
;******    - Dust*************
Dust_METR 
	movlw	b'10000101'	;   
	call	LEDcom		;

	movlw	14h	                  ;D
	call	LEDdata
	movlw	25h	                ;U
	call	LEDdata
   	movlw	23h	             ;   S
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata
              RETURN                     ;
;*************************
;=============================================
;    -
;
;OK=============================================
Bin2LCD                     ;
    	bcf        STATUS,0
        movlw      .32
        movwf      Count
    	clrf       LED4
        clrf       LED3
        clrf       LED2
        clrf       LED1
        clrf       LED0
loop32
        rlf        TimerL,f
        rlf        TimerM,f
        rlf        TimerH,f
        rlf        TimerHH,f
        rlf        LED0,f
        rlf        LED1,f
        rlf        LED2,f
        rlf        LED3,f
        rlf        LED4,f
        decfsz     Count,f
        goto       adjDEC
        movfw      LED4
        andlw      0Fh
        movwf      LED8
        swapf      LED3,w
        andlw      0Fh
        movwf      LED7
        movfw      LED3
        andlw      0Fh
        movwf      LED6
        swapf      LED2,w
        andlw      0Fh
        movwf      LED5
        movfw      LED2
        andlw      0Fh
        movwf      LED4
        swapf      LED1,w
        andlw      0Fh
        movwf      LED3
        movfw      LED1
        andlw      0Fh
        movwf      LED2
        swapf      LED0,w
        andlw      0Fh
        movwf      LED1
        movfw      LED0
        andlw      0Fh
        movwf      LED0           ;
        return
adjDEC                        ;
        movlw      LED0   ;
        movwf      FSR
        call       adjBCD
        movlw      LED1
        movwf      FSR
     	call       adjBCD
        movlw      LED2
        movwf      FSR
        call       adjBCD
        movlw      LED3
        movwf      FSR
        call       adjBCD
    	movlw      LED4
        movwf      FSR
        call       adjBCD
        goto       loop32
adjBCD
        movlw      3
        addwf      0,w
        movwf      Count2
        btfsc      Count2,3
        movwf      0
        movlw      30
        addwf      0,w
        movwf      Count2
        btfsc      Count2,7
        movwf      0
        retlw      0
;********************************************************
;  
;********************************************************
INIT_GKI                           ; . 
      CALL    _T30mS               ;
	movlw	b'00110000'	;  
	call	LEDcom        ;
      CALL    _T30mS               ;
	movlw	b'00110000'	;  
	call	LEDcom        ;
      CALL    _T2mS               ;
	movlw	b'00110000'	;  
	call	LEDcom        ;
	movlw	b'00000010'	;  (  )	
	call	LEDcom        ;
	movlw	b'00000001'	; 
	call	LEDcom
	movlw	b'00001100'	   ; , ,.)
	call	LEDcom
	movlw	b'00101000'	    ;  (4-)
	call	LEDcom
        RETURN                     ;  
;   .=============================================
LEDdata	               ;
       	bsf	PORTB,RB2	;1   RS 
	movwf	LEDtemp		;   
	addlw	30h		;    
          CALL   LED_LCD              ;    
	call	ST
	movf	LEDtemp,w
	addlw	30h
	movwf	Temp
	swapf	Temp,w       ;
          CALL   LED_LCD              ;    
	call	ST
	movf	LEDtemp,w
    return
;   .=============================================
LEDcom	               ;		
       	bcf	PORTB,RB2	;0   RS 
	movwf	LEDtemp      ;
      CALL   LED_LCD              ;    
	call	ST
	movf 	LEDtemp,w
	movwf	Temp
	swapf	Temp,w 		; 
      CALL   LED_LCD              ;    
	call	ST            ;
    CALL     _T2mS             ;
    return
; -.=============================================
ST                               ;
       	bsf	  PORTB,RB3 ;1   E 
	nop			;
	nop			;
	nop			;  
	nop			; 
       	bcf	    PORTB,RB3      ;0   E 
     	movlw	.25		;
	movwf	Temp
_ST                                  ;
	decfsz  Temp,f
	goto   _ST 
    return
;  .=============================================
LED_LCD	               ;		
    MOVWF    W_TEMP             ;
       BTFSS  W_TEMP,4            ;
       BCF   PORTB,RB4           ;
       BTFSC  W_TEMP,4            ;
       BSF   PORTB,RB4           ;
       BTFSS  W_TEMP,5            ;
       BCF   PORTB,RB5           ;
       BTFSC  W_TEMP,5            ;
       BSF   PORTB,RB5           ;
       BTFSS  W_TEMP,6            ;
       BCF   PORTB,RB6           ;
       BTFSC  W_TEMP,6            ;
       BSF   PORTB,RB6           ;
       BTFSS  W_TEMP,7            ;
       BCF   PORTB,RB7           ;
       BTFSC  W_TEMP,7            ;
       BSF   PORTB,RB7           ;
    return
;**********************************************************
;.
;**************************************************************
T_10uS                             ;  10us
        MOVLW   .0        ;
        MOVWF   REG_T         ;
T10uS                             ;
       INCF  REG_T,F              ;
       BTFSS   REG_T,1             ;
       GOTO    T10uS               ;
       CLRF    REG_T               ;
       RETURN                     ;
;**************************************************************
T_60uS                             ;  60us
        MOVLW   .0        ;
        MOVWF   REG_T         ;
T60uS                             ;
       INCF  REG_T,F              ;
       BTFSS   REG_T,4             ;
       GOTO    T60uS               ;
       CLRF    REG_T               ;
       RETURN                     ;
;**************************************************************
T_02mS                             ;  200us
        MOVLW   .15        ;
        MOVWF   REG_T         ;
T02mS                             ;
       INCF  REG_T,F              ;
       BTFSS   REG_T,6             ;
       GOTO    T02mS               ;
       CLRF    REG_T               ;
       RETURN                     ;
;**************************************************************
_T2mS                             ;  2ms
       CLRF    TMR0               ;
T2mS                              ;
       BTFSS   TMR0,3             ;
       GOTO    T2mS               ;
       CLRF    TMR0               ;
       RETURN                     ;
;**************************************************************
T_20mS                             ;  20ms
       CLRF    TMR0               ;
T20mS                              
       BTFSS   TMR0,6             ;
       GOTO    T20mS               ;
       BTFSS   TMR0,3             ;
       GOTO    T20mS               ;
       CLRF    TMR0               ;
       RETURN                     ;
;**************************************************************
_T30mS                             ;  30ms
       CLRF    TMR0               ;
T30mS                              
       BTFSS   TMR0,7             ;
       GOTO    T30mS               ;
       CLRF    TMR0               ;
       RETURN                     ;
;**********************************************************
T2S                              ;  4
       CLRF    REG_T              ;
T_2S                               ;
       BTFSS   INTCON,2           ;
       GOTO    T_2S                ;
       BCF   INTCON,2             ;
       INCF  REG_T,F              ;
              BTFSS   REG_T,6            ;REG_T,5
       GOTO   T_2S                 ;
       CLRF    REG_T              ;
       RETURN                     ;
;***************************************************************
;**************************************************************
;**************************************************************
AD_OFF                      ;
     CLRF   ADCON0               ;
     movlw   B'00000111'       ;
     bsf     STATUS,RP0       ;
     movwf   ADCON1           ;
     bcf     STATUS,RP0       ;
     RETURN                      ;
;******   - air parameters************************************
A_METR 
	movlw	b'10000001'	;   
	call	LEDcom		;
	movlw	11h	               ;A
	call	LEDdata
   	movlw	19h	                  ;I
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
      movlw	 50h	         ;
      call	LEDdata                 ;

	movlw	1Dh	                  ;M
	call	LEDdata
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	1Eh	                  ;N
	call	LEDdata
   	movlw	19h	                  ;I
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
   	movlw	19h	                  ;I
	call	LEDdata
	movlw	1Eh	                  ;N
	call	LEDdata
    movlw	17h	                  ;G
	call	LEDdata
       RETURN                      ;
;********************************************************
;ZAP_Y                      ;
    	movlw	1FCh	           ;,
    	call	LEDdata             ;
        RETURN                     ;
;***************************************************************
INIT_0                           ;
	movlw	REG_T		
	movwf	FSR
	movlw	W_TEMP      ;  
	movwf	Count
	movf 	FSR,w
      subwf   Count,f 
R_clrf1				;   
	clrf	INDF  
	incf	FSR,f
	decfsz	Count,f
	goto	R_clrf1
        RETURN                     ;
INIT_1                           ;
        CLRF    PIR1           ;
      CLRF   TMR1L             ;
      CLRF   TMR1H             ;
        CLRF    Count           ;
        CLRF   Count2            ;
                CALL   INIT_LED              ;
           CALL   INIT_TEMP              ;
           CALL   INIT_TEMP10              ;
           CALL   INIT_TEMP20              ;
INIT_T                           ;
      CLRF     TimerL          ;
INIT_T1                           ;
        CLRF     TimerM          ;
INIT_T2                           ;
        CLRF     TimerH        ;
        CLRF     TimerHH          ;
             RETURN             ;
INIT_TEMP                           ;
        CLRF     TEMP_L          ;
INIT_TEMP1                           ;
        CLRF     TEMP_M          ;
INIT_TEMP2                           ;
        CLRF     TEMP_H          ;
        CLRF     TEMP_HH          ;
           CLRF     TEMP_HHH          ;
             RETURN             ;
INIT_TEMP10                           ;
        CLRF     TEMP_L1          ;
INIT_TEMP11                           ;
        CLRF     TEMP_M1         ;
INIT_TEMP12                           ;
        CLRF     TEMP_H1          ;
        CLRF     TEMP_HH1          ;
          CLRF     TEMP_HHH1          ;
             RETURN             ;
INIT_TEMP20                           ;
        CLRF     TEMP_L2          ;
INIT_TEMP21                           ;
        CLRF     TEMP_M2          ;
INIT_TEMP22                           ;
        CLRF     TEMP_H2          ;
        CLRF     TEMP_HH2          ;
           CLRF     TEMP_HHH2          ;
             RETURN             ;
INIT_LED                           ;
        CLRF     LED0          ;
        CLRF     LED1          ;
        CLRF     LED2          ;
        CLRF     LED3          ;
        CLRF     LED4          ;
        CLRF     LED5          ;
        CLRF     LED6          ;
        CLRF     LED7          ;
        CLRF     LED8          ;
             RETURN             ;











;**************************************************************

      ORG   0x805

;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;**********************************************************
bmp_0

              clrf        flag              ;   

              movlw       b'11101110'       ; (BMP180)
              movwf       slave_adr

              call        paus              ;   5,3 
              movlw       .22               ;    (22 )  2-  
              movwf       tmp_i2c           ;
              movlw       0xAA              ;      
              movwf       adr_i2c           ;
              bsf         flag,3            ;     
              call        read_i2c          ;    I2C
              call        err_prov          ;   / I2C
     
bmp_1
         call        rd_temp           ;      BMP180

              movlw       data_i2c          ;    T
              movwf       FSR 
              bsf         STATUS,RP0   
              movf        INDF,W                       
              movwf       T_LH
              incf        FSR,F 
              movf        INDF,W
              movwf       T_LL
              bcf         STATUS,RP0          

              movlw       .0                ;    (16-19, 0-3(oss))
              movwf       oss
              call        rd_pres           ;      BMP180

              movlw       data_i2c          ;    P
              movwf       FSR  
              bsf         STATUS,RP0  
              movf        INDF,W
              movwf       P_HL
              incf        FSR,F 
              movf        INDF,W
              movwf       P_LH
              incf        FSR,F 
              movf        INDF,W
              movwf       P_LL
              clrf        P_HH
              bcf         STATUS,RP0
              movf        oss,W             ;     P
              sublw       .8                ;    
              bsf         STATUS,RP0
              movwf       tmp
bmp_2
         bcf         STATUS,C
              rrf         P_HH,F
              rrf         P_HL,F
              rrf         P_LH,F
              rrf         P_LL,F
              decfsz      tmp,F
              goto        bmp_2
         call        rash_T_P          ;      
           
              bsf         STATUS,RP0        ;     bin
              movf        T_HH,W
              bcf         STATUS,RP0
              movwf       bin_HH
              bsf         STATUS,RP0
              movf        T_HL,W
              bcf         STATUS,RP0
              movwf       bin_HL
              bsf         STATUS,RP0
              movf        T_LH,W
              bcf         STATUS,RP0
              movwf       bin_LH
              bsf         STATUS,RP0
              movf        T_LL,W
              bcf         STATUS,RP0
              movwf       bin_LL 
      BCF   PCLATH,3
      BCF   PCLATH,4                
        call        vivod_temp        ;    LCD
      BSF   PCLATH,3
      BCF   PCLATH,4
              bsf         STATUS,RP0
              movf        P_M,W             ;   ( . )   bin 
              bcf         STATUS,RP0
              movwf       bin_LH
              bsf         STATUS,RP0
              movf        P_L,W
              bcf         STATUS,RP0
              movwf       bin_LL
              clrf        bin_HL
              clrf        bin_HH
      BCF   PCLATH,3
      BCF   PCLATH,4
          call        viv_p_mm          ;   ( ..)  LCD
      BSF   PCLATH,3
      BCF   PCLATH,4
              bsf         STATUS,RP0        ;     bin
              movf        P_HH,W
              bcf         STATUS,RP0
              movwf       bin_HH
              bsf         STATUS,RP0
              movf        P_HL,W
              bcf         STATUS,RP0
              movwf       bin_HL
              bsf         STATUS,RP0
              movf        P_LH,W
              bcf         STATUS,RP0
              movwf       bin_LH
              bsf         STATUS,RP0
              movf        P_LL,W
              bcf         STATUS,RP0
              movwf       bin_LL


      BCF   PCLATH,3
      BCF   PCLATH,4
          goto        vivod_p           ;   ()  LCD

;          call        vivod_p           ;   ()  LCD
 ;                return                        ;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       BMP180   I2C
            
rd_temp       movlw       0x2E              ;    
              movwf       data_i2c           
              goto        rd_bmp1
             
rd_pres       movlw       0x34              ;       
              movwf       data_i2c          ;   
              movf        oss,W
              movwf       perem
              incf        perem,F
pres_2        decfsz      perem,F
              goto        pres_1
              goto        rd_bmp1

pres_1        movlw       0x40
              addwf       data_i2c,F
              goto        pres_2

rd_bmp1       movlw       .1                ;     I2C
              movwf       tmp_i2c           ;    I2C
              movlw       0xF4              ;
              movwf       adr_i2c           ;      
              call        write_i2c         ;    I2C
              call        err_prov          ;   / I2C
 
rd_bmp2       call        paus              ;   5,3 

              movlw       .1                ;  
              movwf       tmp_i2c           ;    I2C
              movlw       0xF4              ;
              movwf       adr_i2c           ;      
              call        read_i2c          ;    I2C
              call        err_prov          ;   / I2C

              movlw      data_i2c
              movwf      FSR 

              btfsc      INDF,5             ;   
              goto       rd_bmp2            ;  :    rd_bmp2

              movlw       .3                ;  
              movwf       tmp_i2c           ; 3-   I2C
              movlw       0xF6              ;
              movwf       adr_i2c           ;      
              call        read_i2c          ;    I2C
              call        err_prov          ;   / I2C
              return                        ;  

err_prov      btfss       flag,6            ;    I2C
              return                        ; :    
err_1         bsf         led               ;:   led
              goto        err_1             ;   err_1:  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rash_T_P      bsf         STATUS,RP0        ;  2- 

              clrf        REGA3             ;   UT  REGA
              clrf        REGA2
              movf        T_LH,W
              movwf       REGA1
              movf        T_LL,W
              movwf       REGA0

              clrf        REGB3             ;   AC6  REGB
              clrf        REGB2
              movf        AC6_LH,W
              movwf       REGB1
              movf        AC6_LL,W
              movwf       REGB0

              call        subtract          ; UT-AC6

              clrf        REGB3             ;   AC5  REGB
              clrf        REGB2
              movf        AC5_LH,W
              movwf       REGB1
              movf        AC5_LL,W
              movwf       REGB0

              call        multiply          ; (UT-AC6)*AC5

              movlw       .15               ; [(UT-AC6)*AC5]/2^15 = X1
              movwf       tmp
tdel_a1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        tdel_a1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       MD_LH,7           ;   MD  REGB
              goto        tzag_a1
              clrf        REGB3
              clrf        REGB2
              goto        tzag_a2
tzag_a1       movlw       .255
              movwf       REGB3
              movlw       .255
              movwf       REGB2
tzag_a2       movf        MD_LH,W
              movwf       REGB1
              movf        MD_LL,W
              movwf       REGB0

              call        add               ; X1+MD

              movf        REGA0,W           ;  (X1+MD)  REGB
              movwf       REGB0            
              movf        REGA1,W         
              movwf       REGB1
              movf        REGA2,W         
              movwf       REGB2
              movf        REGA3,W         
              movwf       REGB3  
 
              btfsc       MC_LH,7           ;   MC
              goto        tzag_b1
              clrf        REGA3
              clrf        REGA2
              goto        tzag_b2
tzag_b1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
tzag_b2       movf        MC_LH,W
              movwf       REGA1
              movf        MC_LL,W
              movwf       REGA0
              
              movlw       .11               ; MC * 2^11
              movwf       tmp
tumn_a1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        tumn_a1

              call        divide            ; (MC * 2^11)/(X1+MD) = X2

              movf        X1_HH,W           ;  X1  REGB
              movwf       REGB3
              movf        X1_HL,W
              movwf       REGB2
              movf        X1_LH,W
              movwf       REGB1
              movf        X1_LL,W
              movwf       REGB0

              call        add               ; X1 + X2 = B5

              movf        REGA3,W           ;    B5
              movwf       B5_HH
              movf        REGA2,W
              movwf       B5_HL
              movf        REGA1,W
              movwf       B5_LH
              movf        REGA0,W
              movwf       B5_LL

              movlw       .8                ;  8  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; B5 + 8

              movlw       .4                ; (B5 + 8)/2^4
              movwf       tmp
tdel_b1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        tdel_b1

              movf        REGA0,W           ;     T
              movwf       T_LL
              movf        REGA1,W
              movwf       T_LH
              movf        REGA2,W
              movwf       T_HL
              movf        REGA3,W
              movwf       T_HH

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rash_P        movf        B5_HH,W           ;  B5  REGA
              movwf       REGA3
              movf        B5_HL,W
              movwf       REGA2
              movf        B5_LH,W
              movwf       REGA1
              movf        B5_LL,W
              movwf       REGA0

                            
              clrf        REGB3             ;  4000  REGB
              clrf        REGB2
              movlw       0x0F
              movwf       REGB1
              movlw       0xA0
              movwf       REGB0

              call        subtract          ; B5 - 4000 = B6

              movf        REGA3,W           ;    B6  REGB
              movwf       B6_HH
              movwf       REGB3
              movf        REGA2,W
              movwf       B6_HL
              movwf       REGB2
              movf        REGA1,W
              movwf       B6_LH
              movwf       REGB1
              movf        REGA0,W
              movwf       B6_LL
              movwf       REGB0

              call        multiply          ; B6 * B6

              movlw       .12               ; (B6 * B6)/2^12
              movwf       tmp
pdel_a1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_a1

              movf        REGA3,W           ;  ((B6 * B6)/2^12)   X2
              movwf       X2_HH             ;  ,   X2   
              movf        REGA2,W
              movwf       X2_HL
              movf        REGA1,W
              movwf       X2_LH
              movf        REGA0,W
              movwf       X2_LL

              btfsc       B2_LH,7           ;   B2  REGB
              goto        pzag_a1
              clrf        REGB3
              clrf        REGB2
              goto        pzag_a2
pzag_a1       movlw       .255
              movwf       REGB3
              movlw       .255
              movwf       REGB2
pzag_a2       movf        B2_LH,W
              movwf       REGB1
              movf        B2_LL,W
              movwf       REGB0

              call        multiply          ; B2 * [(B6 * B6)/2^12]

              movlw       .11               ; (B2 * [(B6 * B6)/2^12])/2^11
              movwf       tmp
pdel_b1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_b1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       AC2_LH,7          ;   AC2  REGA
              goto        pzag_b1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_b2
pzag_b1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_b2       movf        AC2_LH,W
              movwf       REGA1
              movf        AC2_LL,W
              movwf       REGA0

              movf        B6_LL,W           ;  B6  REGB
              movwf       REGB0            
              movf        B6_LH,W         
              movwf       REGB1
              movf        B6_HL,W         
              movwf       REGB2
              movf        B6_HH,W         
              movwf       REGB3  

              call        multiply          ; AC2 * B6

              movlw       .11               ; (AC2 * B6)/2^11 = X2
              movwf       tmp
pdel_c1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_c1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  

              call        add               ; X1 + X2 = X3

              movf        REGA3,W           ;    X3
              movwf       X3_HH
              movf        REGA2,W
              movwf       X3_HL
              movf        REGA1,W
              movwf       X3_LH
              movf        REGA0,W
              movwf       X3_LL

              btfsc       AC1_LH,7          ;   AC1  REGA
              goto        pzag_c1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_c2
pzag_c1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_c2       movf        AC1_LH,W
              movwf       REGA1
              movf        AC1_LL,W
              movwf       REGA0

              movlw       .2                ; AC1 * 4
              movwf       tmp
pumn_a1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        pumn_a1

              movf        X3_LL,W           ;  X3  REGB
              movwf       REGB0            
              movf        X3_LH,W         
              movwf       REGB1
              movf        X3_HL,W         
              movwf       REGB2
              movf        X3_HH,W         
              movwf       REGB3  

              call        add               ; (AC1 * 4) + X3

              bcf         STATUS,RP0
              movf        oss,W             ; ((AC1 * 4) + X3)<<oss
              xorlw       .0
              bsf         STATUS,RP0
              btfsc       STATUS,Z
              goto        pumn_c1
              bcf         STATUS,RP0
              movf        oss,W 
              bsf         STATUS,RP0              
              movwf       tmp
pumn_b1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        pumn_b1

pumn_c1       movlw       .2                ;  2  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; [((AC1 * 4) + X3)<<oss] + 2

              movlw       .2                ; ([((AC1 * 4) + X3)<<oss] + 2)/4
              movwf       tmp
pdel_d1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_d1
 
              movf        REGA3,W           ;    B3
              movwf       B3_HH
              movf        REGA2,W
              movwf       B3_HL
              movf        REGA1,W
              movwf       B3_LH
              movf        REGA0,W
              movwf       B3_LL

              btfsc       AC3_LH,7          ;   AC3  REGA
              goto        pzag_d1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_d2
pzag_d1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_d2       movf        AC3_LH,W
              movwf       REGA1
              movf        AC3_LL,W
              movwf       REGA0

              movf        B6_LL,W           ;  B6  REGB
              movwf       REGB0            
              movf        B6_LH,W         
              movwf       REGB1
              movf        B6_HL,W         
              movwf       REGB2
              movf        B6_HH,W         
              movwf       REGB3  

              call        multiply          ; AC3 * B6

              movlw       .13               ; (AC3 * B6)/2^13 = X1
              movwf       tmp
pdel_e1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_e1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       B1_LH,7           ;   B1  REGA
              goto        pzag_e1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_e2
pzag_e1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_e2       movf        B1_LH,W
              movwf       REGA1
              movf        B1_LL,W
              movwf       REGA0

              movf        X2_LL,W           ;  (B6 * B6)/2^12  X2  REGB
              movwf       REGB0            
              movf        X2_LH,W         
              movwf       REGB1
              movf        X2_HL,W         
              movwf       REGB2
              movf        X2_HH,W         
              movwf       REGB3  

              call        multiply          ; B1 * ((B6 * B6)/2^12)

              movlw       .16               ; (B1 * ((B6 * B6)/2^12))/2^16 = X2
              movwf       tmp
pdel_f1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_f1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  

              call        add               ; X1 + X2

              movlw       .2                ;  2  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; (X1 + X2) + 2

              movlw       .2                ; ((X1 + X2) + 2)/4 = X3
              movwf       tmp
pdel_g1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_g1                     
               
              clrf        REGB3             ;  32768  REGB
              clrf        REGB2
              movlw       0x80
              movwf       REGB1
              clrf        REGB0

              call        add               ; X3 + 32768 

              clrf        REGB3             ;   AC4  REGB
              clrf        REGB2
              movf        AC4_LH,W
              movwf       REGB1
              movf        AC4_LL,W
              movwf       REGB0

              call        multiply          ; AC4 * (X3 + 32768)

              movlw       .15               ; (AC4 * (X3 + 32768)/2^15) = B4
              movwf       tmp
pdel_h1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_h1

              movf        REGA3,W           ;    B4
              movwf       B4_HH
              movf        REGA2,W
              movwf       B4_HL
              movf        REGA1,W
              movwf       B4_LH
              movf        REGA0,W
              movwf       B4_LL

              movf        P_HH,W            ;  UP  REGA
              movwf       REGA3
              movf        P_HL,W
              movwf       REGA2
              movf        P_LH,W
              movwf       REGA1
              movf        P_LL,W
              movwf       REGA0

              movf        B3_LL,W           ;  B3  REGB
              movwf       REGB0            
              movf        B3_LH,W         
              movwf       REGB1
              movf        B3_HL,W         
              movwf       REGB2
              movf        B3_HH,W         
              movwf       REGB3  

              call        subtract          ; UP-B3
                
              clrf        REGB3             ;  50000  REGB
              clrf        REGB2
              movlw       0xC3
              movwf       REGB1
              movlw       0x50
              movwf       REGB0

              bcf         STATUS,RP0
              movf        oss,W             ; 50000 >> oss
              xorlw       .0
              bsf         STATUS,RP0
              btfsc       STATUS,Z
              goto        pdel_k1
              bcf         STATUS,RP0
              movf        oss,W 
              bsf         STATUS,RP0              
              movwf       tmp
pdel_j1       rlf         REGB3,W
              rrf         REGB3,F
              rrf         REGB2,F
              rrf         REGB1,F
              rrf         REGB0,F
              decfsz      tmp,F
              goto        pdel_j1

pdel_k1       call        multiply          ; (UP-B3) * (50000 >> oss)

              btfsc       REGA3,7
              goto        rash_P1

              bcf         STATUS,C          ;B7 < 0x80000000  (B7 * 2)
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
            
              movf        B4_LL,W           ;  B4  REGB
              movwf       REGB0           
              movf        B4_LH,W         
              movwf       REGB1
              movf        B4_HL,W         
              movwf       REGB2
              movf        B4_HH,W         
              movwf       REGB3  
              
              call        divide_uns        ;  (B7 * 2)/B4
              goto        rash_P2

rash_P1       movf        B4_LL,W           ;B7 >= 0x80000000,   B4  REGB
              movwf       REGB0            
              movf        B4_LH,W         
              movwf       REGB1
              movf        B4_HL,W         
              movwf       REGB2
              movf        B4_HH,W         
              movwf       REGB3  

              call        divide_uns        ;  B7/B4

              bcf         STATUS,C          ; (B7/B4) * 2
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
             

rash_P2       movf        REGA3,W           ;    P
              movwf       P_HH
              movf        REGA2,W
              movwf       P_HL
              movf        REGA1,W
              movwf       P_LH
              movf        REGA0,W
              movwf       P_LL

              movlw       .8                ; P/2^8
              movwf       tmp
pdel_l1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_l1

              movf        REGA3,W           ;   REGA  REGB
              movwf       REGB3
              movf        REGA2,W
              movwf       REGB2
              movf        REGA1,W
              movwf       REGB1
              movf        REGA0,W
              movwf       REGB0

              call        multiply          ; (P/2^8) * (P/2^8) = X1
             
              clrf        REGB3             ;  3038  REGB
              clrf        REGB2
              movlw       0x0B
              movwf       REGB1
              movlw       0xDE
              movwf       REGB0

              call        multiply          ; X1 * 3038

              movlw       .16               ; (X1 * 3038)/2^16 = X1
              movwf       tmp
pdel_o1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_o1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              movlw       0xFF              ;  -7357  REGA
              movwf       REGA3           
              movlw       0xFF
              movwf       REGA2
              movlw       0xE3
              movwf       REGA1
              movlw       0x43
              movwf       REGA0
    
              movf        P_LL,W            ;  P  REGB
              movwf       REGB0           
              movf        P_LH,W         
              movwf       REGB1
              movf        P_HL,W         
              movwf       REGB2
              movf        P_HH,W         
              movwf       REGB3  

              call        multiply          ; (-7357) * P

              movlw       .16               ; ((-7357) * P)/2^16 = X2
              movwf       tmp
pdel_p1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_p1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  
 
              call        add               ; (X1 + X2)

              clrf        REGB3             ;  3791  REGB
              clrf        REGB2
              movlw       0x0E
              movwf       REGB1
              movlw       0xCF
              movwf       REGB0

              call        add               ; (X1 + X2)+3791

              movlw       .4                ; ((X1 + X2)+3791)/2^4
              movwf       tmp
pdel_q1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_q1

              movf        P_LL,W            ;  P  REGB
              movwf       REGB0            
              movf        P_LH,W         
              movwf       REGB1
              movf        P_HL,W       
              movwf       REGB2
              movf        P_HH,W         
              movwf       REGB3  

              call        add               ; P + ((X1 + X2)+3791)/2^4 = P

              movf        REGA3,W           ;    P
              movwf       P_HH
              movf        REGA2,W
              movwf       P_HL
              movf        REGA1,W
              movwf       P_LH
              movf        REGA0,W
              movwf       P_LL

              clrf        REGB3             ;  133  REGB
              clrf        REGB2
              clrf        REGB1
              movlw       0x85
              movwf       REGB0

              call        divide            ; P/133    ..

              movf        REGA1,W           ;    P_M, P_L
              movwf       P_M
              movf        REGA0,W
              movwf       P_L
 
              bcf         STATUS,RP0
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;*** 32 BIT SIGNED SUTRACT ***
;REGA - REGB -> REGA
;Return carry set if overflow

subtract
              call        negateb		;Negate REGB
              skpnc
	          return			;Overflow

;*** 32 BIT SIGNED ADD ***
;REGA + REGB -> REGA
;Return carry set if overflow

add	movf	REGA3,w		;Compare signs
	xorwf	REGB3,w
	movwf	MTEMP

	call	addba		;Add REGB to REGA

	clrc			;Check signs
	movf	REGB3,w		;If signs are same
	xorwf	REGA3,w		;so must result sign
	btfss	MTEMP,7		;else overflow
	addlw	0x80
	return

;*** 32 BIT SIGNED MULTIPLY ***
;REGA * REGB -> REGA
;Return carry set if overflow

multiply
	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpc
	call	absb		;Make REGB positive
	skpnc
	return			;Overflow

	call	movac		;Move REGA to REGC
	call	clra		;Clear product

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

muloop	call	slac		;Shift left product and multiplicand
	
	rlf	REGC3,w		;Test MSB of multiplicand
	skpnc			;If multiplicand bit is a 1 then
	call	addba		;add multiplier to product

	skpc			;Check for overflow
	rlf	REGA3,w
	skpnc
	return

	decfsz	MCOUNT,f	;Next
	goto	muloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

;*** 32 BIT SIGNED DIVIDE ***
;REGA / REGB -> REGA
;Remainder in REGC
;Return carry set if overflow or division by zero

divide	clrf	MTEMP		;Reset sign flag
	movf	REGB0,w		;Trap division by zero
	iorwf	REGB1,w
	iorwf	REGB2,w
	iorwf	REGB3,w
	sublw	0
	skpc
	call	absa		;Make dividend (REGA) positive
	skpc
	call	absb		;Make divisor (REGB) positive
	skpnc
	return			;Overflow

dv_un	clrf	REGC0		;Clear remainder
	clrf	REGC1
	clrf	REGC2
	clrf	REGC3
	call	slac		;Purge sign bit

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

dvloop	call	slac		;Shift dividend (REGA) msb into remainder (REGC)

	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	dtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	dtstgt
	movf	REGB0,w
	subwf	REGC0,w
dtstgt	skpc			;Carry set if remainder >= divisor
	goto	dremlt

	movf	REGB0,w		;Subtract divisor (REGB) from remainder (REGC)
	subwf	REGC0,f
	movf	REGB1,w
	skpc
	incfsz	REGB1,w
	subwf	REGC1,f
	movf	REGB2,w
	skpc
	incfsz	REGB2,w
	subwf	REGC2,f
	movf	REGB3,w
	skpc
	incfsz	REGB3,w
	subwf	REGC3,f
	clrc
	bsf	REGA0,0		;Set quotient bit

dremlt	decfsz	MCOUNT,f	;Next
	goto	dvloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

divide_uns   clrf	MTEMP		;Reset sign flag
	         movf	REGB0,w		;Trap division by zero
          	 iorwf	REGB1,w
	         iorwf	REGB2,w
   	         iorwf	REGB3,w
	         sublw	0
	         skpnc
	         return			;Overflow
             goto   dv_un

;Add REGB to REGA (Unsigned)
;Used by add, multiply,

addba	movf	REGB0,w		;Add lo byte
	addwf	REGA0,f

	movf	REGB1,w		;Add mid-lo byte
	skpnc			;No carry_in, so just add
	incfsz	REGB1,w		;Add carry_in to REGB
	addwf	REGA1,f		;Add and propagate carry_out

	movf	REGB2,w		;Add mid-hi byte
	skpnc
	incfsz	REGB2,w
	addwf	REGA2,f

	movf	REGB3,w		;Add hi byte
	skpnc
	incfsz	REGB3,w
	addwf	REGA3,f
	return

;Move REGA to REGC
;Used by multiply, sqrt

movac	movf	REGA0,w
	movwf	REGC0
	movf	REGA1,w
	movwf	REGC1
	movf	REGA2,w
	movwf	REGC2
	movf	REGA3,w
	movwf	REGC3
	return

;Clear REGA
;Used by multiply, sqrt

clra	clrf	REGA0
	clrf	REGA1
	clrf	REGA2
	clrf	REGA3
	return

;Check sign of REGA and convert negative to positive
;Used by multiply, divide, bin2dec, round

absa	rlf	REGA3,w
	skpc
	return			;Positive

;Negate REGA
;Used by absa, multiply, divide, bin2dec, dec2bin, round

negatea	movf	REGA3,w		;Save sign in w
	andlw	0x80

	comf	REGA0,f		;2's complement
	comf	REGA1,f
	comf	REGA2,f
	comf	REGA3,f
	incfsz	REGA0,f
	goto	nega1
	incfsz	REGA1,f
	goto	nega1
	incfsz	REGA2,f
	goto	nega1
	incf	REGA3,f
nega1
	incf	MTEMP,f		;flip sign flag
	addwf	REGA3,w		;Return carry set if -2147483648
	return


;Check sign of REGB and convert negative to positive
;Used by multiply, divide

absb	rlf	REGB3,w
	skpc
	return			;Positive

;Negate REGB
;Used by absb, subtract, multiply, divide

negateb	movf	REGB3,w		;Save sign in w
	andlw	0x80

	comf	REGB0,f		;2's complement
	comf	REGB1,f
	comf	REGB2,f
	comf	REGB3,f
	incfsz	REGB0,f
	goto	negb1
	incfsz	REGB1,f
	goto	negb1
	incfsz	REGB2,f
	goto	negb1
	incf	REGB3,f
negb1
	incf	MTEMP,f		;flip sign flag
	addwf	REGB3,w		;Return carry set if -2147483648
	return

;Shift left REGA and REGC
;Used by multiply, divide, round

slac	rlf	REGA0,f
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f
slc	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	return



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; /   I2C

write_i2c     bsf         flag,4            ;  
              goto        i2c_1             ;   i2c_1
read_i2c      bcf         flag,4            ;  ( )
              bcf         flag,5            ;   
i2c_1         bcf         flag,6            ;   I2C
              call        starti2c          ;  ""  I2C
            
              bcf         slave_adr,0       ;  
              movf        slave_adr,W       ;  
              call        peredi2c          ; 
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              movf        adr_i2c,W         ;  I2C
              call        peredi2c          ;   
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c
          
              btfss       flag,3            ;     
              goto        i2c_3
              bcf         flag,3
              movlw       AC1_LH
              goto        i2c_4  
i2c_3         movlw       data_i2c       
i2c_4         movwf       FSR
              decf        FSR,F

              btfss       flag,4            ;  / I2C
              goto        rd_i2c            ;   rd_i2c ()

i2c_2         incf        FSR,F
              movf        INDF,W            ;   
              call        peredi2c          ;   I2C
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              decfsz      tmp_i2c,F
              goto        i2c_2
              call        stopi2c 
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rd_i2c        call        starti2c          ;  ( )
              bsf         slave_adr,0       ;  
              movf        slave_adr,W       ;  
              call        peredi2c          ; 
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

rd_i2c_2      decfsz      tmp_i2c,F
              goto        rd_i2c_1
              bsf         flag,5
rd_i2c_1      incf        FSR,F
              call        priemi2c          ; 
            
              movwf       INDF
              movlw       .0
              xorwf       tmp_i2c,F
              btfss       STATUS,Z
              goto        rd_i2c_2
              call        stopi2c           ; 
              return

err_i2c       call        stopi2c           ;  ""  I2C 
              return                        ;        I2C
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

starti2c      call        scl_1              ;  scl
              call        pausi2c            ; I2C (5 )
              call        sda_0              ;  0  sda
              call        pausi2c            ; I2C (5 )
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              return                         ;  

stopi2c       call        sda_0              ;  0  sda
              call        pausi2c            ; I2C (5 )
              call        scl_1              ;  scl
stpi2c_1      call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        stpi2c_1           ;
              call        sda_1              ;  sda
              call        pausi2c            ; I2C (5 )
              return                         ;  

sda_1         bsf         STATUS,RP0         ;  sda  
              bsf         sda_io             ;        
              bcf         STATUS,RP0         ;
              return                         ;  

sda_0         bcf         sda                ;  sda  
              bsf         STATUS,RP0         ;
              bcf         sda_io             ;
              bcf         STATUS,RP0         ;
              return                         ;  

scl_1         bsf         STATUS,RP0         ;  scl  
              bsf         scl_io             ;        
              bcf         STATUS,RP0         ;
              return                        ;  

scl_0         bcf         scl                ;  scl  
              bsf         STATUS,RP0         ;
              bcf         scl_io             ;
              bcf         STATUS,RP0         ;
              return                         ;  


peredi2c      movwf       perem              ;    i2c
              movlw       .8                 ;
              movwf       scetbit            ;
prd_i2c_1     btfsc       perem,7            ;
              call        sda_1              ;  sda
              btfss       perem,7            ;
              call        sda_0              ;  0  sda
              call        scl_1              ;  scl
prd_i2c_2     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prd_i2c_2          ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              rlf         perem,F            ;
              decfsz      scetbit,F          ;
              goto        prd_i2c_1          ;
            
              call        sda_1              ;  sda
              call        scl_1              ;  scl
prd_i2c_3     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prd_i2c_3          ;

              movlw       .20                ;  100 
              movwf       scetbit            ;
prd_i2c_4     btfss       sda                ;	
              goto        prd_i2c_5          ;
              decfsz      scetbit,F          ; 
              goto        prd_i2c_4          ;
              bsf         flag,6             ; ,    
prd_i2c_5     call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              return                         ;  


priemi2c      movlw       .8                 ;    i2c
              movwf       scetbit            ;
              call        sda_1              ;  sda
prm_i2c_1     rlf         perem,F            ;
              call        scl_1              ;  scl
prm_i2c_2     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prm_i2c_2          ;
              btfsc       sda                ;
              bsf         perem,0            ;
              btfss       sda                ;
              bcf         perem,0            ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              decfsz      scetbit,F          ;
              goto        prm_i2c_1          ;
 
              btfss       flag,5             ;
              call        sda_0              ;  0  sda

              call        scl_1              ;  scl
prm_i2c_3     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prm_i2c_3          ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              movf        perem,W            ;
              return                         ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pausi2c       nop                            ;  I2C (5 )
              return                         ;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
paus          movlw       .7                ;  5,3 
              movwf       Sec1              ;
p_l2          movlw       .255              ;
              movwf       Sec               ;
p_l1          decfsz      Sec,F             ;
              goto        p_l1              ;
              decfsz      Sec1,F            ;
              goto        p_l2              ;
              return


; *****************************
 END                              ;
; *****************************



;   ,   MH-Z19        .            2  ,        4001000, 10002000  > 2000 ppm,     .

;        ,             .      :

;        5          3,3 ,           ;
;            ,        ;
;              ,     -  .  ,      5        -    CO2;
;        .     ,     .

;*************************
CO2_R                        ;   
;088      HIGH  LOW  5000ppm   :
;HIGH = 5000 / 256; LOW = 5000 % 256;

	movlw	0FFh		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	01h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	87h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	00h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	movlw	78h		;
	movwf	TXREG	
	call	out_busy
    	call	_T2mS
	return
